﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Infragistics.Controls.Grids;
using System.Collections.ObjectModel;

namespace DynamicalColumns
{
    public partial class MainPage : UserControl
    {
        ViewModel vm = new ViewModel();
        public MainPage()
        {
            InitializeComponent();
            DataContext = vm;
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            vm.AddChildren();
            int index = vm.Data.FirstOrDefault().Children.Count - 1;

            TextColumn idCol = new TextColumn
            {
                Key = "Children[" + index + "].ID",
                HeaderText = "Children " + index + " Id",
            };
            xamGrid1.Columns.Add(idCol);
            
            TextColumn nameCol = new TextColumn
            {
                Key = "Children[" + index + "].Name",
                HeaderText = "Children " + index + " Name",
            };
            xamGrid1.Columns.Add(nameCol);
        }
    }

    public class ViewModel
    {
        public ViewModel()
        {
            Data = new ObservableCollection<Entity>();
            for (int i = 0; i < 10; i++)
            {
                Data.Add(new Entity
                {
                    ID = i,
                    Name = "Name " + i,
                    Children = new ObservableCollection<Entity>()
                });
            }
        }

        public void AddChildren()
        {
            Random r = new Random();
            foreach (var item in Data)
            {
                item.Children.Add(new Entity
                {
                    ID = r.Next(100),
                    Name = "Name " + r.Next(100)
                });
            }
        }

        public ObservableCollection<Entity> Data { get; set; }
    }



    public class Entity
    {
        public int ID { get; set; }
        public string Name { get; set; }

        public ObservableCollection<Entity> Children { get; set; }
    }
}
